/*    This SQL DDL script was generated by Microsoft Visual Studio (Release Date: LOCAL BUILD). */


/* Create new table "ApplicationUserRole".                                                    */
/* "ApplicationUserRole" : Table of ApplicationUserRole                                       */  
create table "ApplicationUserRole" ( 
    "ApplicationId" int not null,
    "UserId" int not null,
    "RoleId" int not null)  

go

alter table "ApplicationUserRole"
    add constraint "ApplicationUserRole_PK" primary key ("ApplicationId", "UserId", "RoleId")   


go

/* Create new table "ApplicationUser".                                                        */
/* "ApplicationUser" : Table of ApplicationUser                                               */  
create table "ApplicationUser" ( 
    "ApplicationId" int not null,
    "UserId" int not null)  

go

alter table "ApplicationUser"
    add constraint "ApplicationUser_PK" primary key ("ApplicationId", "UserId")   


go

/* Create new table "ApplicationRole".                                                        */
/* "ApplicationRole" : Table of ApplicationRole                                               */  
create table "ApplicationRole" ( 
    "ApplicationId" int not null,
    "RoleId" int not null)  

go

alter table "ApplicationRole"
    add constraint "ApplicationRole_PK" primary key ("ApplicationId", "RoleId")   


go

/* Create new table "Role".                                                                   */
/* "Role" : Table of Role                                                                     */  
create table "Role" ( 
    "Id" int identity not null,
    "Name" varchar(255) not null,
    "LoweredName" varchar(255) not null,
    "Description" varchar(255) null)  

go

alter table "Role"
    add constraint "Role_PK" primary key ("Id")   


go

/* Create new table "MembershipUser".                                                         */
/* "MembershipUser" : Table of MembershipUser                                                 */  
create table "MembershipUser" ( 
    "Id" int identity not null,
    "Name" varchar(255) not null,
    "LoweredName" varchar(255) not null,
    "Description" varchar(255) null,
    "Password" varchar(128) not null,
    "PasswordFormat" int not null,
    "PasswordSalt" varchar(128) not null,
    "Email" varchar(128) not null,
    "LoweredEmail" varchar(128) not null,
    "PasswordQuestion" varchar(255) null,
    "PasswordAnswer" varchar(255) null,
    "Comments" varchar(3000) null,
    "IsApproved" bit not null,
    "IsLockedOut" bit not null,
    "CreationDate" datetime not null,
    "LastActivityDate" datetime not null,
    "LastLoginDate" datetime not null,
    "LastLockedOutDate" datetime not null,
    "LastPasswordChangeDate" datetime not null,
    "FailedPwdAttemptCnt" int not null,
    "FailedPwdAttemptWndStart" datetime not null,
    "FailedPwdAnsAttemptCnt" int not null,
    "FailedPwdAnsAttemptWndStart" datetime not null)  

go

alter table "MembershipUser"
    add constraint "MembershipUser_PK" primary key ("Id")   


go

/* Create new table "Application".                                                            */
/* "Application" : Table of Application                                                       */  
create table "Application" ( 
    "Id" int identity not null,
    "Name" varchar(255) not null,
    "LoweredName" varchar(255) not null,
    "Description" varchar(255) null)  

go

alter table "Application"
    add constraint "Application_PK" primary key nonclustered ("Id")   


go

/* Add the remaining keys, constraints and indexes for the table "ApplicationRole".           */
create index "ApplicationRole_IDX1" on "ApplicationRole" (
    "RoleId")  


go

/* Add the remaining keys, constraints and indexes for the table "Role".                      */
alter table "Role" add constraint "Role_UC1" unique (
    "LoweredName")  


go

/* Add the remaining keys, constraints and indexes for the table "MembershipUser".            */
alter table "MembershipUser" add constraint "MembershipUser_UC1" unique (
    "LoweredName")  


go

create index "MembershipUser_IDX2" on "MembershipUser" (
    "LastActivityDate")  


go

/* Add the remaining keys, constraints and indexes for the table "Application".               */
alter table "Application" add constraint "Application_UC1" unique (
    "LoweredName")  


go

/* Add foreign key constraints to table "ApplicationUserRole".                                */
alter table "ApplicationUserRole"
    add constraint "App_AppUserRole_FK1" foreign key (
        "ApplicationId")
     references "Application" (
        "Id") on update no action on delete no action  

go

alter table "ApplicationUserRole"
    add constraint "User_AppUserRole_FK1" foreign key (
        "UserId")
     references "MembershipUser" (
        "Id") on update no action on delete no action  

go

alter table "ApplicationUserRole"
    add constraint "Role_AppUserRole_FK1" foreign key (
        "RoleId")
     references "Role" (
        "Id") on update no action on delete no action  

go

/* Add foreign key constraints to table "ApplicationUser".                                    */
alter table "ApplicationUser"
    add constraint "App_AppUser_FK1" foreign key (
        "ApplicationId")
     references "Application" (
        "Id") on update no action on delete no action  

go

alter table "ApplicationUser"
    add constraint "User_AppUser_FK1" foreign key (
        "UserId")
     references "MembershipUser" (
        "Id") on update no action on delete no action  

go

/* Add foreign key constraints to table "ApplicationRole".                                    */
alter table "ApplicationRole"
    add constraint "App_AppRole_FK1" foreign key (
        "ApplicationId")
     references "Application" (
        "Id") on update no action on delete no action  

go

alter table "ApplicationRole"
    add constraint "Role_AppRole_FK1" foreign key (
        "RoleId")
     references "Role" (
        "Id") on update no action on delete no action  

go


/* This is the end of the Microsoft Visual Studio generated SQL DDL script.                   */
