/*    This SQL DDL script was generated by Microsoft Visual Studio (Release Date: LOCAL BUILD). */


/*
drop table APPLICATIONUSERROLE;
drop table APPLICATIONUSER;
drop table APPLICATIONROLE;
drop table ROLE;
drop table MEMBERSHIPUSER;
drop table APPLICATION;
*/

-- Create new table APPLICATIONUSERROLE.
-- APPLICATIONUSERROLE : Table of ApplicationUserRole  
create table APPLICATIONUSERROLE (
	APPLICATIONID NUMBER(38,0) not null,
	USERID NUMBER(38,0) not null,
	ROLEID NUMBER(38,0) not null, constraint APPLICATIONUSERROLE_PK primary key (APPLICATIONID, USERID, ROLEID) ); 

-- Create new table APPLICATIONUSER.
-- APPLICATIONUSER : Table of ApplicationUser  
create table APPLICATIONUSER (
	APPLICATIONID NUMBER(38,0) not null,
	USERID NUMBER(38,0) not null, constraint APPLICATIONUSER_PK primary key (APPLICATIONID, USERID) ); 

-- Create new table APPLICATIONROLE.
-- APPLICATIONROLE : Table of ApplicationRole  
create table APPLICATIONROLE (
	APPLICATIONID NUMBER(38,0) not null,
	ROLEID NUMBER(38,0) not null, constraint APPLICATIONROLE_PK primary key (APPLICATIONID, ROLEID) ); 

-- Create new table ROLE.
-- ROLE : Table of Role  
create table ROLE (
	ID NUMBER(38,0) not null,
	NAME VARCHAR2(255) not null,
	LOWEREDNAME VARCHAR2(255) not null,
	DESCRIPTION VARCHAR2(255) null, constraint ROLE_PK primary key (ID) ); 

-- Create new table MEMBERSHIPUSER.
-- MEMBERSHIPUSER : Table of MembershipUser  
create table MEMBERSHIPUSER (
	ID NUMBER(38,0) not null,
	NAME VARCHAR2(255) not null,
	LOWEREDNAME VARCHAR2(255) not null,
	DESCRIPTION VARCHAR2(255) null,
	PASSWORD VARCHAR2(128) not null,
	PASSWORDFORMAT NUMBER(38,0) not null,
	PASSWORDSALT VARCHAR2(128) not null,
	EMAIL VARCHAR2(128) not null,
	LOWEREDEMAIL VARCHAR2(128) not null,
	PASSWORDQUESTION VARCHAR2(255) null,
	PASSWORDANSWER VARCHAR2(255) null,
	COMMENTS VARCHAR2(3000) null,
	ISAPPROVED CHAR(1) not null,
	ISLOCKEDOUT CHAR(1) not null,
	CREATIONDATE DATE not null,
	LASTACTIVITYDATE DATE not null,
	LASTLOGINDATE DATE not null,
	LASTLOCKEDOUTDATE DATE not null,
	LASTPASSWORDCHANGEDATE DATE not null,
	FAILEDPWDATTEMPTCNT NUMBER(38,0) not null,
	FAILEDPWDATTEMPTWNDSTART DATE not null,
	FAILEDPWDANSATTEMPTCNT NUMBER(38,0) not null,
	FAILEDPWDANSATTEMPTWNDSTART DATE not null, constraint MEMBERSHIPUSER_PK primary key (ID) ); 

-- Create new table APPLICATION.
-- APPLICATION : Table of Application  
create table APPLICATION (
	ID NUMBER(38,0) not null,
	NAME VARCHAR2(255) not null,
	LOWEREDNAME VARCHAR2(255) not null,
	DESCRIPTION VARCHAR2(255) null, constraint APPLICATION_PK primary key (ID) ); 

-- Add the remaining keys, constraints and indexes for the table APPLICATIONROLE.
create index APPLICATIONROLE_IDX1 on APPLICATIONROLE (
	ROLEID ASC); 


-- Add the remaining keys, constraints and indexes for the table ROLE.
alter table ROLE add constraint ROLE_UC1 unique (
	LOWEREDNAME); 


-- Add the remaining keys, constraints and indexes for the table MEMBERSHIPUSER.
alter table MEMBERSHIPUSER add constraint MEMBERSHIPUSER_UC1 unique (
	LOWEREDNAME); 


create index MEMBERSHIPUSER_IDX2 on MEMBERSHIPUSER (
	LASTACTIVITYDATE ASC); 


-- Add the remaining keys, constraints and indexes for the table APPLICATION.
alter table APPLICATION add constraint APPLICATION_UC1 unique (
	LOWEREDNAME); 


-- Add foreign key constraints to table APPLICATIONUSERROLE.
alter table APPLICATIONUSERROLE
	add constraint APP_APPUSERROLE_FK1 foreign key (
		APPLICATIONID)
	 references APPLICATION (
		ID); 

alter table APPLICATIONUSERROLE
	add constraint USER_APPUSERROLE_FK1 foreign key (
		USERID)
	 references MEMBERSHIPUSER (
		ID); 

alter table APPLICATIONUSERROLE
	add constraint ROLE_APPUSERROLE_FK1 foreign key (
		ROLEID)
	 references ROLE (
		ID); 

-- Add foreign key constraints to table APPLICATIONUSER.
alter table APPLICATIONUSER
	add constraint APP_APPUSER_FK1 foreign key (
		APPLICATIONID)
	 references APPLICATION (
		ID); 

alter table APPLICATIONUSER
	add constraint USER_APPUSER_FK1 foreign key (
		USERID)
	 references MEMBERSHIPUSER (
		ID); 

-- Add foreign key constraints to table APPLICATIONROLE.
alter table APPLICATIONROLE
	add constraint APP_APPROLE_FK1 foreign key (
		APPLICATIONID)
	 references APPLICATION (
		ID); 

alter table APPLICATIONROLE
	add constraint ROLE_APPROLE_FK1 foreign key (
		ROLEID)
	 references ROLE (
		ID); 


-- Create user defined sequences for all the newly created tables.

-- Create table level sequence for table Application.
CREATE SEQUENCE Application_Id_SEQ
    MINVALUE 1
    START WITH 1
    INCREMENT BY 1;


-- Create table level sequence for table Role.
CREATE SEQUENCE Role_Id_SEQ
    MINVALUE 1
    START WITH 1
    INCREMENT BY 1;


-- Create table level sequence for table User.
CREATE SEQUENCE User_Id_SEQ
    MINVALUE 1
    START WITH 1
    INCREMENT BY 1;


/*
-- Create/Recreate user defined triggers for all the newly create and changed tables.

-- Create table level triggers for table Application.
CREATE OR REPLACE TRIGGER Application_Insert BEFORE INSERT ON Application
FOR EACH ROW
BEGIN
        SELECT Application_Id_SEQ.NextVal
          INTO :NEW.Id
          FROM DUAL;
END;


-- Create table level triggers for table Role.
CREATE OR REPLACE TRIGGER Role_Insert BEFORE INSERT ON Role
FOR EACH ROW
BEGIN
        SELECT Role_Id_SEQ.NextVal
          INTO :NEW.Id
          FROM DUAL;
END;


-- Create table level triggers for table MembershipUser.
CREATE OR REPLACE TRIGGER User_Insert BEFORE INSERT ON MembershipUser
FOR EACH ROW
BEGIN
        SELECT User_Id_SEQ.NextVal
          INTO :NEW.Id
          FROM DUAL;
END;
*/


/* This is the end of the Microsoft Visual Studio generated SQL DDL script.                   */
